Contiguous Array - Leetcode 525 - Python

🚀 neetcode.io/ - A better way to prepare for Coding Interviews
🧑‍💼 LinkedIn: / navdeep-singh-3aaa14161
🐦 Twitter: / neetcode1
⭐ BLIND-75 PLAYLIST: • Two Sum - Leetcode 1 -...
Problem Link: leetcode.com/problems/contigu...
0:00 - Read the problem
0:30 - Drawing Explanation
11:31 - Coding Explanation
leetcode 525
#neetcode #leetcode #python

Пікірлер: 64

  • @MP-ny3ep
    @MP-ny3ep4 ай бұрын

    What sets you apart from the other youtubers is the fact that you don't just explain the solution. You also explain why other methods don't work? why only this method works? and how exactly do we come up with this solution? This video was an amazing explanation . Thank you for that.

  • @thisisnotok2100
    @thisisnotok21004 ай бұрын

    I would never think of this without seeing it before.

  • @BRBallin1

    @BRBallin1

    Ай бұрын

    I think the idea is you are aware of the solution. Whether you came up with it on your own or not is not the point.

  • @NeetCodeIO
    @NeetCodeIO4 ай бұрын

    What does everyone think of the new leetcode UI? Kinda annoying that they don't let you switch back to the old one anymore

  • @Ahmed.Shaikh

    @Ahmed.Shaikh

    4 ай бұрын

    I started leeting in the new UI and accidentally switched to the OG UI once through some keyboard shortcut. I was terrified of the old UI. Glad I was able to switch back to the new one. It just depends on what you're used to.

  • @user-yd9dr6yr7o

    @user-yd9dr6yr7o

    4 ай бұрын

    ya, it's better to be able to switch between them

  • @cheese-grater255

    @cheese-grater255

    4 ай бұрын

    I immediately thought of a sliding window and tried that, thanks for explaining why that wouldn't work. That type of explanation, mentioning why a particular solution doesn't work in this case is really really helpful.

  • @ellisfrancisfarros3935

    @ellisfrancisfarros3935

    4 ай бұрын

    I just got into LeetCoding recently so I'm cool with it. If I could try the old UI I would.

  • @chien-yucode992

    @chien-yucode992

    4 ай бұрын

    Same here

  • @chinmaywalinjkar7340
    @chinmaywalinjkar73404 ай бұрын

    I signed my Apple summer internship offer letter yesterday, thanks a lot for all your help. I hope you continue doing what you do the best

  • @BRBallin1
    @BRBallin1Ай бұрын

    Very interesting approach. This is the TDLR for the comment section: 1. Maintain a count variable as you iterate through array. For each 0 subtract count by 1 and add by 1 for each 1. 2. Maintain a hash map in which you store the leftmost index for each count value and initialize it with 0: -1 3. As you iterate through the array if the current count value already exists in the hash map, update the size with curr_idx - map[curr_count] if that value is greater than the greatest size so far

  • @infinity5503
    @infinity55034 ай бұрын

    I was struggling with visualising the solutions, Thank for such easy explanation.

  • @apoorvakhuspe2203
    @apoorvakhuspe22034 ай бұрын

    Hi Navdeep, thank you for your solution! It will be extremely helpful if you include the brainstorming notes too in the future videos. Thanks!

  • @CSwithSolve
    @CSwithSolve4 ай бұрын

    Congrats on 100k 🎊

  • @LlamaBG
    @LlamaBG4 ай бұрын

    sick, thanks for continuing to make these

  • @ellisfrancisfarros3935
    @ellisfrancisfarros39354 ай бұрын

    Congrats on 100k!

  • @mfandrade
    @mfandrade4 ай бұрын

    Finally an explanation I understood perfectly. Thanks!

  • @ahmedtremo
    @ahmedtremo4 ай бұрын

    Amazing explanation today, thanks

  • @rthnrj
    @rthnrj4 ай бұрын

    Great solution as usual. 🔥 But, hope the following might make it less complex: In simple terms, in the array, if you see 1 -> preSum - 1 0 -> preSum + 1 Then, you just have to check two cases - 1. If the preSum is 0 (equal number of 1s and 0s till that index) -> update result index 2. If the preSum already exists -> check the difference - NOTE: Should not update the hashmap (we only want the first seen preSum to stay to maximise the result) If not both, we are seeing this preSum for the first time -> Add it to hashmap

  • @rthnrj

    @rthnrj

    4 ай бұрын

    Code for better understanding: def findMaxLength(self, nums: List[int]) -> int: preSum = 0 ans = 0 d = {} for i in range(len(nums)): #calculating preSum if nums[i] == 0: preSum += 1 else: preSum -= 1 #if the preSum is zero -> equal number of 1s ansd 0s if preSum == 0: ans = max(ans, i + 1) #the other case is that we have seen it already elif preSum in d: ans = max(ans, i - d[preSum]) #seeing this preSum for the first time else: d[preSum] = i return ans

  • @swaroopas5207

    @swaroopas5207

    4 ай бұрын

    Perfect even i was thinking the same. Simple and easy to understand

  • @hadiajavaid1056
    @hadiajavaid10564 ай бұрын

    The comments are a great addition, Navdeep Paji

  • @kienduongngo7549
    @kienduongngo7549Ай бұрын

    very smart. the solution is so clean

  • @alxolr
    @alxolr4 ай бұрын

    These problems are beautiful and set apart top-level coders from the rest. Hope one day to be able to solve this kind of problems myself.

  • @llorensbf

    @llorensbf

    4 ай бұрын

    this particular problem sets apart people that has spent a huge amount of time on leetcode and somehow got the intuition for this, from people who may well be great coders but don't grind leetcode

  • @alxolr

    @alxolr

    4 ай бұрын

    @@llorensbf That's also true, i would not give this problem at an interview as it doesn't show much technique.

  • @heybeachMIN
    @heybeachMIN3 күн бұрын

    Yes, please show me another solution where you use -1 and 1. I would really like to see him, in general, this is a very difficult task for me. Thank you for the video!

  • @chien-yucode992
    @chien-yucode9924 ай бұрын

    Amazing :D

  • @spsc07
    @spsc074 ай бұрын

    hey @NeetCodeIO at 0:46 wont it be !n (factorial of n) rather than n^2 (n squared) ??

  • @dcvc619

    @dcvc619

    4 ай бұрын

    n! is equal to n * n-1 * n-2 * .... * 2 * 1, while the solution at 0:46 is n + n-1 + n-2 + .... + 2 + 1 which is (n(n+1))/2 which we simplify to O(n^2)

  • @yang5843
    @yang58434 ай бұрын

    It's a Prefix sum problem

  • @anirbandas12
    @anirbandas124 ай бұрын

    Just find the prefixSum arr, add 1 if 1 or -1 if 0 or vice versa, use hashMap to compare prev values but don't store when the sum repeats otherwise it will overwrite, check the sum=0 case also

  • @rahulsihara8946
    @rahulsihara89464 ай бұрын

    it was great explanation, I do understand the solution after watching your video. But how coming up with such solution is not intuitive for me, could you please help with that in any way?

  • @omarmohamedshaheen3654
    @omarmohamedshaheen36544 ай бұрын

    Hey @NeetCodeIO, won't it be a better solution to use double pointers one at index 0 (s) and another at index n -1 (e), and increment or decrement s and e depending on the number of 1es. if sum(array[s:e]) * 2 > (e - s + 1), s++ if array[s] == 1 or e-- if array[e] == 1 else if sum(array[s:e]) * 2 else return array[s:e]. let me know what you think.

  • @mdshahadatkabir7536
    @mdshahadatkabir75364 ай бұрын

    please make complete playlist with problem sovling using python in from any online patfrom

  • @supercarpro
    @supercarpro3 ай бұрын

    How have you not won awards for your work. Been using your solutions for years now, I love you neetcode🌸

  • @NeetCodeIO

    @NeetCodeIO

    3 ай бұрын

    Thank you so much 🙏

  • @olegleonov1310
    @olegleonov13104 ай бұрын

    What if we count all zeroes and ones first time and will use sliding window by decreasing it from right and left. For example, we have 3 zeros and 5 ones. We will decrease the side where we have ones or zeros if we don't have ones from each side and each time update(decrease) zeros and ones values. Will it work?

  • @anirbanhossen6170
    @anirbanhossen61704 ай бұрын

    leetcode- Replace Question Marks in String to Minimize Its Value. Solve this question in python in easiest way.

  • @jarjarbinks8954
    @jarjarbinks89544 ай бұрын

    does it matter if the array starts with a 0?

  • @huyennguyenmaingoc468
    @huyennguyenmaingoc4683 ай бұрын

    This is so intelligent and I still can’t figure out how can you come up with this solution XD

  • @rumonintokyo
    @rumonintokyo2 ай бұрын

    love the solution but I aint never coming up with this during an interview without prior knowledge.

  • @pastori2672
    @pastori26724 ай бұрын

    one day ill be like you

  • @thunder_cs
    @thunder_cs4 ай бұрын

    Honestly I didn't think that much but I was able to solve the question :p. My thought process was "how about I get the largest array with sum = 0 and how to do that? consider every 0 as a -1"

  • @rahulaggarwal3977
    @rahulaggarwal39774 ай бұрын

    yup

  • @chaitanyayeole4111
    @chaitanyayeole41114 ай бұрын

    @NeetCodeIO, you can shift the sliding window. Suppose we have array = [1, 1, 1, 0, 0, 0]. As the the maximum length of the array is 6. We can consider the length of the array as a limit. If the sliding window has 3 one's and 2 zero's, and the length of the array is 6 then we can definitely shift our right side by 1. But if we have 4 one' and 1 zero's, the shifting the right side by does not make sense. So we will shift the left side of the window by 1.

  • @belphegor32
    @belphegor324 ай бұрын

    I am in the final grade in Russian Highschool, and I actually saw this problem preparing for my informatics exam (it was not with 0s and 1s, it was the problem to find the longest window that has the largest sum that meets all the requirements, but the idea was also about to keep all the prefixes), it was the last problem in the previous year's exam. I hope I will not get something like this, because I wont be able to solve it under the pressure, haha

  • @lucav.k.7588
    @lucav.k.75882 ай бұрын

    How are you supposed to know this without seeing it before :(

  • @0praveen
    @0praveen4 ай бұрын

    please keep the comments NC !!

  • @austinmclaughlin8407
    @austinmclaughlin84074 ай бұрын

    Include comments! Sometimes the hardest part is intuiting the solution, so seeing how you got from Sliding Window to this Prefix Sum is interesting. Glad to have your videos & roadmap as I prep for interviews. Thx a bunch.

  • @abdmo7575
    @abdmo75754 ай бұрын

    censoring dislikes from leetcode is annoying AF

  • @fieworjohn5697
    @fieworjohn56974 ай бұрын

    am i the only one who wasn't able to pass all the testcases with this? here's my code, just in case someone can help point out my mistake class Solution: def findMaxLength(self, nums: List[int]) -> int: zeros, ones = 0, 0 diff_index = {} res = 0 for i, n in enumerate(nums): if i == 0: zeros += 1 else: ones += 1 if ones - zeros not in diff_index: diff_index[ones - zeros] = i if ones == zeros: res = ones + zeros else: idx = diff_index[ones - zeros] res = max(res, i - idx) return res

  • @silverblade3377

    @silverblade3377

    4 ай бұрын

    I guess you've already figured it out, but just in case you haven't, your code should be: if n == 0: zeroes += 1 else: ones += 1 Because you need to be checking if each element of the array is equal to zero, not if the index is zero.

  • @fieworjohn5697

    @fieworjohn5697

    4 ай бұрын

    @@silverblade3377 Oh my. Thanks!

  • @smortlogician9258
    @smortlogician92584 ай бұрын

    People are still learning dsa? Whym